﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr137_3
{
    // Класс с несколькими индексаторами: 
    class MyClass
    {
        // Закрытый строковый массив:
        private string[] text;
        // Конструктор класса с одним аргументом: 
        public MyClass(string[] t)
        {
            // Создание массива: 
            text = new string[t.Length];
            // Заполнение массива:
            for (int k = 0; k < t.Length; k++)
            {
                // Использование индексатора: 
                text[k] = t[k];
            }
        }
        // Переопределение метода ToString(): 
        public override string ToString()
        {
            // Текстовая переменная:
            string txt = "Содержимое объекта:\n";
            // Формирование текстовой строки: 
            for (int k = 0; k < text.Length; k++)
            {
                txt += "\"" + text[k] + "\""+ (k == text.Length - 1 ? "\n" : " ");
            }
            // Результат метода: 
            return txt;
        }
        // Индексатор с целочисленным индексом: 
        public string this[int k]
        {
            // Аксессор для считывания значения: 
            get
            {
                return text[k];
            }
            // Аксессор для присваивания значения: 
            set
            {
                if (k < 0 || k >= text.Length) return;
                text[k] = value;
            }
        }
        // Индексатор с двумя целочисленными индексами: 
        public string this[int k, int l]
        {
            // Аксессор для считывания значения: 
            get
            {
                // Циклическая перестановка:
                if (k < 0 || k >= text.Length)
                {
                    int temp = k;
                    k = l;
                    l = temp;
                }
                // Циклическая перестановка:
                if (l < 0 || l >= text[k].Length)
                {
                    int temp = k;
                    k = l;
                    l = temp;
                }
                // Возвращаемый символ:
                return text[k].Substring(l, 1);
            }
        }
    }

    // Класс с главным методом:
    class Program
    {
        // Главный метод:
        static void Main()
        {
            string[] t = {"мама", "мыла", "раму", "с", "мылом"};
            MyClass obj = new MyClass(t);
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Использование одномерного индексатора:
            obj[0] = "папа";
            obj[1] = "мыл";
            // Проверка использования одномерного индексатора:
            Console.WriteLine("obj[{0}] = {1}", 0, obj[0]);
            Console.WriteLine("obj[{0}] = {1}", 1, obj[1]);
            // Проверка содержимого объекта:
            Console.WriteLine("\n" + obj);
            // Проверка использования двумерного индексатора:
            Console.WriteLine("obj[{0}, {1}] = {2}", 0, 2, obj[0, 2]);
            // Проверка циклической перестановки индексов
            Console.WriteLine("obj[{0}, {1}] = {2}", 2, 4, obj[2, 4]);
            // Проверка содержимого объекта:
            Console.WriteLine("\n" + obj);
            // Задержка:
            Console.ReadLine();
        }
    }
}
